/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.modelflattening.models;

import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * The product documentation.
 */
public class BaseProduct {
    /**
     * Unique identifier representing a specific product for a given latitude
     * &amp; longitude. For example, uberX in San Francisco will have a
     * different product_id than uberX in Los Angeles.
     */
    @JsonProperty(value = "base_product_id", required = true)
    private String productId;

    /**
     * Description of product.
     */
    @JsonProperty(value = "base_product_description")
    private String description;

    /**
     * Get the productId value.
     *
     * @return the productId value
     */
    public String getProductId() {
        return this.productId;
    }

    /**
     * Set the productId value.
     *
     * @param productId the productId value to set
     */
    public void setProductId(String productId) {
        this.productId = productId;
    }

    /**
     * Get the description value.
     *
     * @return the description value
     */
    public String getDescription() {
        return this.description;
    }

    /**
     * Set the description value.
     *
     * @param description the description value to set
     */
    public void setDescription(String description) {
        this.description = description;
    }

}
