/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var util = require('util');
var msRest = require('ms-rest');
var ServiceClient = msRest.ServiceClient;

var models = require('./models');
var operations = require('./operations');

/**
 * @class
 * Initializes a new instance of the AutoRestParameterizedCustomHostTestClient class.
 * @constructor
 *
 * @param {string} subscriptionId - The subscription id with value 'test12'.
 *
 * @param {object} [options] - The parameter options
 *
 * @param {Array} [options.filters] - Filters to be added to the request pipeline
 *
 * @param {object} [options.requestOptions] - Options for the underlying request object
 * {@link https://github.com/request/request#requestoptions-callback Options doc}
 *
 * @param {boolean} [options.noRetryPolicy] - If set to true, turn off default retry policy
 *
 * @param {string} [options.dnsSuffix] - A string value that is used as a global part of the parameterized host. Default value 'host'.
 *
 */
function AutoRestParameterizedCustomHostTestClient(subscriptionId, options) {
  this.dnsSuffix = 'host';
  if (subscriptionId === null || subscriptionId === undefined) {
    throw new Error('\'subscriptionId\' cannot be null.');
  }

  if (!options) options = {};

  AutoRestParameterizedCustomHostTestClient['super_'].call(this, null, options);
  this.baseUri = '{vault}{secret}{dnsSuffix}';
  this.subscriptionId = subscriptionId;

  if(options.dnsSuffix !== null && options.dnsSuffix !== undefined) { 
    this.dnsSuffix = options.dnsSuffix;
  }
  this.paths = new operations.Paths(this);
  this.models = models;
  msRest.addSerializationMixin(this);
}

util.inherits(AutoRestParameterizedCustomHostTestClient, ServiceClient);

module.exports = AutoRestParameterizedCustomHostTestClient;
